Subject: [P2PSIP] implementation must *lead* standardization

From: "Henry Sinnreich" <[email-masked]>
Date: Fri, 21 Sep 2007 06:37:04 -0700

The attached for a related list is an interesting and useful comment for our efforts on P2PSIP.
Thanks, Henry

________________________________________
From: [email-masked] [mailto:[email-masked]] On Behalf Of David Barrett
Sent: Thursday, September 20, 2007 8:59 PM
To: 'theory and practice of decentralized computer networks'
Subject: Re: [p2p-hackers] Best NAT traversal options

I'm astonished, but I actually agree with Lemon on this one.

HTTP was largely invented by a single guy, Tim Berners-Lee, by improving upon the best ideas from previous systems *without attempting to be compatible*.  He also wrote the first browser and server, and the first websites.  He also founded the W3C.

Tim published his HTTP spec in 1991.  Mosiac came out in 1994.  Internet Explorer in 1995.

It wasn't until 1996 - five years *after* the web was already born, and well after it was mainstream - until the IETF got around to standardizing HTTP 1.0.

If anything, HTTP is the prime example of how implementation must *lead* standardization, and that the IETF shouldn't bother trying to invent by committee, but rather find and standardize the best of the existing solutions.

-david
====================================================================

For what it is worth, the P2PP over Bamboo/openDHT are the closest to what we could use IMHO.

Flames?  :-)
 
Henry

_______________________________________________
P2PSIP mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/p2psip

---

From: Hannes Tschofenig <[email-masked]>
Date: Fri, 21 Sep 2007 16:11:34 +0200

I am not sure what your message should actually tell us.

The HTTP example* in fact tells us not only to start getting stuff 
implemented but it also tells us to standardize stuff that is already 
widely deployed.
In the context of this group this would essentially mean that we should 
standardize Skype.

Ciao
Hannes

(*) There are other examples that would tell us to start implementation 
after you finished standardization. Again others tell us to work on 
protoypes during the standardization phase. Finally, there are many 
examples that tell us that prototypes are not enough to get widespread 
deployment.

In essence, you pick your favorite example and use it as a justification 
why to go for one approach and not for another one.

---

From: "Henry Sinnreich" <[email-masked]>
Date: Fri, 21 Sep 2007 07:40:10 -0700

Hannes,

> I am not sure what your message should actually tell us.

Exactly what the title says: implementation must *lead* standardization

>>> If anything, HTTP is the prime example of how implementation must
*lead* >>> standardization, and that the IETF shouldn't bother trying to
invent by >>> committee, but rather find and standardize the best of the
existing 
>>> solutions.

> In the context of this group this would essentially mean that we
should 

I am not sure you have read the whole message.

>> to what we could use IMHO.

How come you did have Skype in mind? :-)

Thanks for following up this item. It was the 'invent by committee' vs.
'implementation before standardization' that is worth discussing IMHO.

Henry

-----Original Message-----
From: Hannes Tschofenig [mailto:[email-masked]] 
Sent: Friday, September 21, 2007 9:12 AM
To: Henry Sinnreich
Cc: P2PSIP Mailing List
Subject: Re: [P2PSIP] implementation must *lead* standardization

Ciao
Hannes

Henry Sinnreich wrote:
> From: [email-masked]
[mailto:[email-masked]] On Behalf Of David Barrett
> HTTP was largely invented by a single guy, Tim Berners-Lee, by
improving upon the best ideas from previous systems *without attempting
to be compatible*.  He also wrote the first browser and server, and the
first websites.  He also founded the W3C.
> It wasn't until 1996 - five years *after* the web was already born,
and well after it was mainstream - until the IETF got around to
standardizing HTTP 1.0.
>
> If anything, HTTP is the prime example of how implementation must
*lead* standardization, and that the IETF shouldn't bother trying to
invent by committee, but rather find and standardize the best of the
existing solutions.

---

From: "Brian Rosen" <[email-masked]>
Date: Fri, 21 Sep 2007 11:14:39 -0400

<as individual>
But Henry, this is the IETF, where we long ago gave up on "running code".

Seriously though, when you have a breakthrough technology, implementation
leads standardization.  Where the protocol issues are more understood, and
it is a matter of choosing between multiple mechanisms all of which can be
seen to work, then we already have the implementations and we are
standardizing based on that.

Of course, what we are doing here is combining "one from column A" and "one
from column B" in the proposals before us, but we don't really have anyone
who is claiming some other proposal won't work.  It's more like "mine is
better because..."

Brian

> From: Henry Sinnreich [mailto:[email-masked]]
> Sent: Friday, September 21, 2007 10:40 AM
> To: Hannes Tschofenig
> Cc: P2PSIP Mailing List
> Subject: RE: [P2PSIP] implementation must *lead* standardization
> 
> Hannes,
>

---

From: "Michael Slavitch" <[email-masked]>
Date: Fri, 21 Sep 2007 12:05:10 -0400

What we >do< have, as Henry mentions, is what TBL provided for HTTP.   Our 
equivalent is Bamboo/DHT.    Columbia is our CERN. We do not yet have Mosaic.

Here is a corresponding anecdote that betrays my age a little.  Bear with me 
please.

I was at a seminar, with Tim Berners-Lee speaking on something called HTTP , 
at Ottawa's Carleton University n 1991 or so, when he showed it off to a bunch 
of engineers and researchers.   This was when TBL was still at CERN.  This is 
before anyone knew who TBL was.  This was before NCSA Mosaic.  This was before 
the Web was born. I believe he had to borrow somebody's NeXT workstation to 
show it off.  Hence the locale as they had one.   There were 25 people, max, 
at this session.   It was so small that the whole remaining crowd went to a 
downtown Malaysian restaurant afterwards and fit around one large table.

At this session a C-level manager (who I know but who will remain unnamed) for 
a large telecoms company stood up and asked this: "is this an ISO standard?"

Tim said:  "No."

C-level then said:  "Then we are most certainly NOT interested!"

He marched off in a huff and ordered his R&D staff to follow him out the door, 
and refused to  allow further discussion on such off-topic matters to
happen on their time.  It became a career ending move to bring it up again, as 
he considered it a waste of time.  That was in 1991.

 In terms of being a C-level answerable to an executive suite, with immediate 
goals, one of them was getting ISDN to be adopted, he was right.

We are at that point with P2PSIP.  We reached that point a couple of years 
ago, actually.  We have the technology but not the wave of use.  TBL thought 
it would  be about physics and citations of papers with embedded data.  It 
turned out to be about bad poetry,  your pets and family pictures,  music, and 
porn.

And to be honest, I thought HTTP was lovely,  ingenious, an "SGML for the rest 
of us, under our control".  SGML, an ISO standard, was horrible.  I know 
because I had the misfortune of having to code for it.  HTML and HTTP were a 
better SGML, running over IP, much in the way that P2PSIP is " communications 
for the rest of us, under our own control".   I loved HTTP/HTML in the same 
way I love P2PSIP now.  I just couldn't convince my bosses to give a damn, as 
I couldn't find an application with a business case.

I didn't really pick up on its full value until NCSA Mosaic showed up, which 
was too late. Unfortunately I was in no position to act on it,  otherwise I'd 
be on some super yacht in Bonaire.  I was working on practical things back 
then, hard problems, like most of us are today.  Of course NCSA Mosaic won: 
It was simple to install, it was simple to develop web pages.  They were easy 
to make pretty.  Non-geeks picked it up and made it pretty.  Mosaic sure beat 
ARCHIE and WAIS, because you didn't have to be a geek to use it or provide 
content.   It had a "WOW" factor, and people could create their own "WOW".

The first big users were sociology students, geology students, art and music 
students, non-technical people, because NCSA Mosaic allowed them to build 
their own content that transmitted text, pictures, and sound, by themselves, 
and not be technical experts.  It was certainly  the first Internet technology 
where outsiders got their hands on Internet technology.  And once 
non-technical people got hold of it they didn't let go, they made sure that it 
stayed focused on their needs, not technology needs.

We don't have a P2PSIP equivalent of NCSA Mosaic that is being picked up by 
25m university students, something that is in the hands of lots of people
who don't give a damn about technology.  Skype is like AOL. It doesn't count. 
NCSA Mosaic created a scale-free network effect because it was useful for a 
broad range of people with a broad range of interests, it could run in its own 
direction, and it was free.  If you are old enough to recall, the MSN Network 
was causing absolute panic that Microsoft would take over the on-line world 
from the likes of CompuServe and AOL,  the Yahoo and Google of their days.
 It didn't, because NCSA Mosaic stole the show.   Explorer came out only after 
the threat of Mosaic was recognized. Until then Microsoft was headed for a 
cliff.  They turned themselves around when somebody under 40 threw a brick 
through the execusphere and somehow it got through.  If it hadn't Microsoft 
could have turned into Novell.

TBL/Mosaic vs.  proprietary on-line systems mirrors today's debate over 
gPhones and iPhones and Microsoft and Skype, not to mention spectrum wars and 
IMS all involving proprietary closed networks,  vs. P2PSIP.   It is quite 
literally about who gets the people. What gets the people will clobber all of 
these things into the dustbin of history.  It can happen again. Facebook is a 
recent example of technology that started for students.  It is proprietary, 
like AOL and Skype.

The Harvard kids who started it had to go to California to get funding because 
every  VC on the East coast laughed.  Facebook is probably worth 6B right now, 
perhaps 10B. Eventually there will be standard interfaces between social 
community software.  They won't be IETF standards however.   W3 standards, 
maybe.

P2PSIP isn't a research item any longer, it's a popularity contest now.  That 
is the core problem that needs to be solved.  I have a hunch that if it is 
solved, which is still not certain,  the solution will have its start on 
campuses,  be free and easy to use for fun as well as for personal profit or 
reputation, and the majority of early adopters will have nothing to do with 
technology except having easy access to new technology that they can choose to 
use and modify to their needs at will.

And by modify I most certainly don't mean the code.

Regards

Michael

Michael Slavitch
Lead,  Technology Initiatives
[email-masked]

Objectworld, The IT Telephony Company TM
308 Legget Drive, Ottawa, Ontario K2K 1Y6
Phone: +1 (613) 599-9698, x. 22 | Fax: +1 (613) 599-7457
http://www.objectworld.com

-----Original Message-----
From: Henry Sinnreich [mailto:[email-masked]]
Sent: Friday, September 21, 2007 10:40 AM
To: Hannes Tschofenig
Cc: P2PSIP Mailing List
Subject: RE: [P2PSIP] implementation must *lead* standardization

Hannes,

Henry

-----Original Message-----
From: Hannes Tschofenig [mailto:[email-masked]]
Sent: Friday, September 21, 2007 9:12 AM
To: Henry Sinnreich
Cc: P2PSIP Mailing List
Subject: Re: [P2PSIP] implementation must *lead* standardization

Ciao
Hannes

--

---

From: "David Barrett" <[email-masked]>
Date: Fri, 21 Sep 2007 11:19:09 -0700

> why to go for one approach and not for another one.

Which examples did you have in mind of extremely successful internet
technologies that were invented on paper by a committee before any
individual implementation gained widespread adoption?

-david

---

From: "Henry Sinnreich" <[email-masked]>
Date: Fri, 21 Sep 2007 11:24:01 -0700

Brian,

You are right about choosing between different mechanisms that are well
understood, such as for example in SIP.

P2PSIP is however not as well understood, especially with NAT traversal
and for this reason designing by committee can lead to failure. 

Yes, there are several very interesting P2PSIP proposals (such as HIP
based) on the table, but each has several key design decisions that must
first be proven by some running code and deployment experience for
different NAT scenarios.

Henry

-----Original Message-----
From: Brian Rosen [mailto:[email-masked]] 
Sent: Friday, September 21, 2007 10:15 AM
To: Henry Sinnreich; 'Hannes Tschofenig'
Cc: 'P2PSIP Mailing List'
Subject: RE: [P2PSIP] implementation must *lead* standardization

<as individual>
But Henry, this is the IETF, where we long ago gave up on "running
code".

Seriously though, when you have a breakthrough technology,
implementation
leads standardization.  Where the protocol issues are more understood,
and
it is a matter of choosing between multiple mechanisms all of which can
be
seen to work, then we already have the implementations and we are
standardizing based on that.

Of course, what we are doing here is combining "one from column A" and
"one
from column B" in the proposals before us, but we don't really have
anyone
who is claiming some other proposal won't work.  It's more like "mine is
better because..."

Brian

> > For what it is worth, the P2PP over Bamboo/openDHT are the closest
to
> what we could use IMHO.

---

From: Hannes Tschofenig <[email-masked]>
Date: Fri, 21 Sep 2007 20:44:05 +0200

Henry,

so let me ask directly. You seem to have a preference for a specific 
proposal (or a small number of them) and you seem to be interested in 
pushing it (or them) with the "is there running code" question. Which 
proposal do you think is far enough regarding their implementation work?

It is fine for me to ask that question knowing that the final 
specification will very likely be so different from the initial proposal.

Don't understand me wrong; I also like running code and produce it as 
part the protocols I have been working on. Still, I believe that there 
is some motivation behind your question and I want to learn more about it.

Ciao
Hannes

PS: Previously you were talking about "implementation" and in your last 
mail below you are additionally speaking about "deployment experience". 
This is an entirely different story.

Henry Sinnreich wrote:
>> Exactly what the title says: implementation must *lead*
>>     
> standardization
>   
>> *lead* >>> standardization, and that the IETF shouldn't bother trying
>>     
> to
>   
>> invent by >>> committee, but rather find and standardize the best of
>>     
> the
>   
>> existing
>>     
>>>>> solutions.
>>>>>           
>>> In the context of this group this would essentially mean that we
>>>       
>> should
>>     
>>> standardize Skype.
>>>       
>>>> to what we could use IMHO.
>>>>         
>> Thanks for following up this item. It was the 'invent by committee'
>>     
> vs.
>   
>> In the context of this group this would essentially mean that we
>>     
> should
>   
>> standardize Skype.
>>
>> Ciao
>> Hannes
>>
>> (*) There are other examples that would tell us to start
>>     
> implementation
>   
>> In essence, you pick your favorite example and use it as a
>>     
> justification
>   
>>> The attached for a related list is an interesting and useful comment
>>>       
>> for our efforts on P2PSIP.
>>     
>>> Thanks, Henry
>>>
>> [mailto:[email-masked]] On Behalf Of David
>>     
> Barrett
>   
>> improving upon the best ideas from previous systems *without
>>     
> attempting
>   
>> to be compatible*.  He also wrote the first browser and server, and
>>     
> the
>   
>>> Tim published his HTTP spec in 1991.  Mosiac came out in 1994.
>>>       
>> Internet Explorer in 1995.
>>